aboutsummaryrefslogtreecommitdiffstats
path: root/bootstrap.bash
diff options
context:
space:
mode:
authorDan Willemsen <dwillemsen@google.com>2015-07-14 00:39:06 -0700
committerDan Willemsen <dwillemsen@google.com>2015-09-17 23:42:25 -0700
commit87b17d1ff46ab86ab897c50435c423f28be4895f (patch)
tree69d5b2ed53c5b99aacef6b3d692256ec0b671d21 /bootstrap.bash
parentc3ba6cb9707730e0fc553fa86b9fe6b6c9bbb4b9 (diff)
downloadbuild_soong-87b17d1ff46ab86ab897c50435c423f28be4895f.tar.gz
build_soong-87b17d1ff46ab86ab897c50435c423f28be4895f.tar.bz2
build_soong-87b17d1ff46ab86ab897c50435c423f28be4895f.zip
Use SRCDIR as a working directory
The existing behavior of using the build directory as the working directory is useful if you want to move/copy the output directory around and SRCDIR still refers the the source. But, it's more useful to have the source directory be the working directory. Tools like cpp(__FILE__) and other debug prints embed relative paths from the working directory. We also have tools that expect the working directory to be $TOP. Change-Id: Ia0f1d3c6b7df72d61cf5628efa2baa98bd19775b
Diffstat (limited to 'bootstrap.bash')
-rwxr-xr-xbootstrap.bash51
1 files changed, 40 insertions, 11 deletions
diff --git a/bootstrap.bash b/bootstrap.bash
index f6056d65..c4c7e35c 100755
--- a/bootstrap.bash
+++ b/bootstrap.bash
@@ -1,7 +1,27 @@
#!/bin/bash
-export BOOTSTRAP="${BASH_SOURCE[0]}"
-export SRCDIR=$(dirname "${BASH_SOURCE[0]}")
+set -e
+
+ORIG_SRCDIR=$(dirname "${BASH_SOURCE[0]}")
+if [[ "$ORIG_SRCDIR" != "." ]]; then
+ if [[ ! -z "$BUILDDIR" ]]; then
+ echo "error: To use BUILDDIR, run from the source directory"
+ exit 1
+ fi
+ if [[ ${ORIG_SRCDIR:0:1} == '/' ]]; then
+ export BUILDDIR=$PWD
+ else
+ export BUILDDIR=$(python -c "import os; print os.path.relpath('.', '$ORIG_SRCDIR')")
+ fi
+ cd $ORIG_SRCDIR
+fi
+if [[ -z "$BUILDDIR" ]]; then
+ echo "error: Run ${BASH_SOURCE[0]} from the build output directory"
+ exit 1
+fi
+export SRCDIR="."
+export BOOTSTRAP="${SRCDIR}/bootstrap.bash"
+
export TOPNAME="Android.bp"
export BOOTSTRAP_MANIFEST="${SRCDIR}/build/soong/build.ninja.in"
export RUN_TESTS="-t"
@@ -21,16 +41,25 @@ export GOROOT="${SRCDIR}/prebuilts/go/$PREBUILTOS/"
export GOARCH="amd64"
export GOCHAR="6"
-if [[ $(find . -maxdepth 1 -name $(basename "${BOOTSTRAP}")) ]]; then
- echo "FAILED: Tried to run "$(basename "${BOOTSTRAP}")" from "$(pwd)""
- exit 1
-fi
-
if [[ $# -eq 0 ]]; then
- sed -e "s|@@SrcDir@@|${SRCDIR}|" \
+ mkdir -p $BUILDDIR
+
+ if [[ $(find $BUILDDIR -maxdepth 1 -name Android.bp) ]]; then
+ echo "FAILED: The build directory must not be a source directory"
+ exit 1
+ fi
+
+ if [[ ${BUILDDIR:0:1} == '/' ]]; then
+ export SRCDIR_FROM_BUILDDIR=$PWD
+ else
+ export SRCDIR_FROM_BUILDDIR=$(python -c "import os; print os.path.relpath('.', '$BUILDDIR')")
+ fi
+
+ sed -e "s|@@BuildDir@@|${BUILDDIR}|" \
+ -e "s|@@SrcDirFromBuildDir@@|${SRCDIR_FROM_BUILDDIR}|" \
-e "s|@@PrebuiltOS@@|${PREBUILTOS}|" \
- "${SRCDIR}/build/soong/soong.bootstrap.in" > .soong.bootstrap
- ln -sf "${SRCDIR}/build/soong/soong.bash" soong
+ "$SRCDIR/build/soong/soong.bootstrap.in" > $BUILDDIR/.soong.bootstrap
+ ln -sf "${SRCDIR_FROM_BUILDDIR}/build/soong/soong.bash" $BUILDDIR/soong
fi
-"${SRCDIR}/build/blueprint/bootstrap.bash" "$@"
+"$SRCDIR/build/blueprint/bootstrap.bash" "$@"